import java.util.HashSet;
import java.util.LinkedList;

public class ConsecutiveTriples {
	
	// return the list of distinct consecutive triples of integers in the table t
	static LinkedList<Triple> distinctConsecutiveTriples(int[] t) {
		HashSet<Triple> setTriples = new HashSet<Triple>();
		for (int i = 0; i < t.length-2; i++) {
			setTriples.add(new Triple(t[i], t[i+1], t[i+2]));
		}
		LinkedList<Triple> listTriples = new LinkedList<Triple>(); 
		listTriples.addAll(setTriples);
		return listTriples;
	}
	
	// return the list of consecutive triples of distinct integers in the table t
	static LinkedList<Triple> consecutiveTriplesDistinctNumbers(int[] t) {
		LinkedList<Triple> listTriples = new LinkedList<Triple>();
		for (int i = 0; i < t.length-2; i++) {
			Triple x = new Triple(t[i], t[i+1], t[i+2]);
			if (x.a != x.b && x.a != x.c && x.b != x.c)
				listTriples.add(x);
		}
		return listTriples;
	}
	
	public static void main(String[] args) {
		LinkedList<Triple> listDistinctTriples = distinctConsecutiveTriples(new int[]{1,1,2,1,3,2,1,3,1});
		System.out.println("number of distinct consecutive triples of numbers " + listDistinctTriples.size());
		for (Triple t : listDistinctTriples)
			System.out.print(t + ", ");
		System.out.println();

		LinkedList<Triple> listTriplesDistinctNumbers = consecutiveTriplesDistinctNumbers(new int[]{1,1,2,1,3,2,1,3,1});
		System.out.println("number of consecutive triples of distinct numbers " + listTriplesDistinctNumbers.size());
		for (Triple t : listTriplesDistinctNumbers)
			System.out.print(t + ", ");

	}
}
