
public class Matrix {
	int size;
	private int[][] data;
	private int numberQueries;
	
	Matrix(int[][] data) {
		size = data.length;
		this.data = data;
		numberQueries = 0;
	}

	// compare data[i][j] with v and increments the number of queries
	int compare(int i, int j, int v) {
		numberQueries++;
		return data[i][j] - v;
	}

	// return the number of queries
	int getNumberQueries() {
		return numberQueries;
	}

	// reset the number of queries
	void resetNumberQueries() {
		numberQueries = 0;
	}

	// basic print of the matrix
	public String toString() {
		String res = "";
		for (int i = 0; i < size; i++) {
			for (int j = 0; j < size; j++)
				res += data[i][j] + " ";
			res += String.format("%n");
		}
		return res;
	}
}
