
public class Test21 {
	
	// construction of relevant matrices
	static Matrix arithmeticMatrix(int size, int a, int b) {
		int[][] data = new int[size][size];
		for (int i = 0; i < size; i++)
			for (int j = 0; j < size; j++)
				data[i][j] = a*i + b*j;
		return new Matrix(data);
	}
	
	// test the method findMatrix 
	static void testFindMatrix(Matrix mat, int i, int j, int v) {
		mat.resetNumberQueries();
		int res = FindMatrix.findMatrix(mat, v);
		int ires = res / mat.size, jres = res % mat.size;
		if (res == -1)
			assert (i == -1) : "\nThe matrix\n" + mat + "contains the value " + v + " at position (" + i + ", " + j + ").\n";
		else {
			assert (i != -1) : "\nThe matrix\n" + mat + "does not contain the value " + v + ".\n";
			assert (mat.compare(ires, jres, v) == 0) : "\nThe value " + v + " does not coincide with the entry at position (" + i + ", " + j + ") in the matrix\n" + mat;
		}
	}

	public static void main(String[] args) {
		// check -ea option on JVM
		if (!Test21.class.desiredAssertionStatus()) {
			System.err.println("Vous devez activer l'option -ea de la JVM");
			System.err.println("(Run As -> Run configurations -> Arguments -> VM Arguments)");
			System.exit(1);
		}
				
		// test findMatrix
		System.out.print("Test de findMatrix ... ");
		int a = 2, b = 3;
		for (int size = 1; size < 10; size++) {
			Matrix mat = arithmeticMatrix(size, a, b);
			for (int i = 0; i < size; i++)
				for (int j = 0; j < size; j++) {
					testFindMatrix(mat, i, j, a*i + b*j);
				}
		}
		System.out.println("[OK]");
	}
}
