
public class Test23 {	
	
	// construction of the Hamming matrix
	static Matrix HammingMatrix(int size) {
		int[][] data = new int[size][size];
		for (int i = 0; i < size; i++)
			for (int j = 0; j < size; j++)
				data[i][j] = (int) (Math.pow(2, i) * Math.pow(3, j));
		return new Matrix(data);
	}

	// test the method HammingMatrix 
	static void testHammingMatrix(int size) {
		Matrix mat1 = HammingMatrix(size);
		Matrix mat2 = FindMatrix.HammingMatrix(size);
		for (int i = 0; i < size; i++)
			for (int j = 0; j < size; j++) {
				int v = (int) (Math.pow(2, i) * Math.pow(3, j));
				assert(mat2.compare(i, j, v) == 0) : "\nThe entry at position (" + i + ", " + j + ") should be " + v + "\nCompare your matrix :\n\n" + mat2 + "\nwith the desired Hamming matrix :\n\n" + mat1;
			}
	}

	public static void main(String[] args) {
		// check -ea option on JVM
		if (!Test23.class.desiredAssertionStatus()) {
			System.err.println("Vous devez activer l'option -ea de la JVM");
			System.err.println("(Run As -> Run configurations -> Arguments -> VM Arguments)");
			System.exit(1);
		}

		// test HammingMatrix
		System.out.print("Test de HammingMatrix ... ");
		for (int size = 1; size <= 10; size++)
			testHammingMatrix(size);
		System.out.println("[OK]\n");
		
		Matrix mat = FindMatrix.HammingMatrix(10);
		System.out.println("Matrice de Hamming de taille 10 :");
		System.out.println(mat);

		System.out.println("Recherche de 512 :");
		System.out.println("position " + FindMatrix.findMatrix(mat, 512) + ", trouvée en " + mat.getNumberQueries() + " requêtes par la méthode FindMatrix de la question 2.1.");
		mat.resetNumberQueries();
		System.out.println("position " + FindMatrix.findDoublySortedMatrix(mat, 512) + ", trouvée en " + mat.getNumberQueries() + " requêtes par la méthode FindDoublySortedMatrix de la question 2.2.");
		mat.resetNumberQueries();
		System.out.println();

		System.out.println("Recherche de 19683 :");
		System.out.println("position " + FindMatrix.findMatrix(mat, 19683) + ", trouvée en " + mat.getNumberQueries() + " requêtes par la méthode FindMatrix de la question 2.1.");
		mat.resetNumberQueries();
		System.out.println("position " + FindMatrix.findDoublySortedMatrix(mat, 19683) + ", trouvée en " + mat.getNumberQueries() + " requêtes par la méthode FindDoublySortedMatrix de la question 2.2.");
		mat.resetNumberQueries();
		System.out.println();

		System.out.println("Recherche de 7776 :");
		System.out.println("position " + FindMatrix.findMatrix(mat, 7776) + ", trouvée en " + mat.getNumberQueries() + " requêtes par la méthode FindMatrix de la question 2.1.");
		mat.resetNumberQueries();
		System.out.println("position " + FindMatrix.findDoublySortedMatrix(mat, 7776) + ", trouvée en " + mat.getNumberQueries() + " requêtes par la méthode FindDoublySortedMatrix de la question 2.2.");
		mat.resetNumberQueries();
	}
}
