
public class Test311 {
	
	// print a tree
	static String print(Tree t) {
		String res = "[";
		for (Tree child : t.children)
			res += print(child);
		return res + "]";
	}
	
	// test the constructor Tree
	static void testTree(Tree t, String s, int height) {
		assert(t.children != null) : "\nYou have not initialized properly the field children.\n";
		assert(print(t).equals(s)) : "\nYou constructed the tree\n   " + print(t) + "\ninstead of the tree " + s + ".\nNote that we represent inductively:\n    * a leaf by the string [] and\n    * a tree t with children {c1,...,ck} by the string s(t) = [s(c1)...s(ck)].\n";
		assert(t.height == height) : "\nThe height ot the tree\n   " + print(t) + "\nis " + height + " not " + t.height + ".\nNote that we represent inductively:\n    * a leaf by the string [] and\n    * a tree t with children {c1,...,ck} by the string s(t) = [s(c1)...s(ck)].\n";
	}
	
	public static void main(String[] args) {
		// check -ea option on JVM
		if (!Test311.class.desiredAssertionStatus()) {
			System.err.println("Vous devez activer l'option -ea de la JVM");
			System.err.println("(Run As -> Run configurations -> Arguments -> VM Arguments)");
			System.exit(1);
		}
				
		// test the constructor on some examples
		System.out.print("Test du constructeur Tree ... ");
		Tree t1 = new Tree(new Tree[] {});
		Tree t2 = new Tree(new Tree[] {new Tree(), new Tree(), new Tree(new Tree[] {new Tree()})});
		Tree t3 = new Tree(new Tree[] {t1, t2});
		Tree t4 = new Tree(new Tree[] {new Tree(), new Tree(new Tree[] {new Tree(), new Tree(), new Tree()}), t3});
		
		testTree(t1, "[]", 1);
		testTree(t2, "[[][][[]]]", 3);
		testTree(t3, "[[][[][][[]]]]", 4);
		testTree(t4, "[[][[][][]][[][[][][[]]]]]", 5);

		System.out.println("[OK]");
	}
}
