
public class Test312 {
	
	// print a tree
	static String print(Tree t) {
		String res = "[";
		for (Tree child : t.children)
			res += print(child);
		return res + "]";
	}

	// mirror of a string
	static String mirror(String s) {
		String rev = new StringBuffer(s).reverse().toString();
		String res = "";
		for (int i = 0; i < rev.length(); i++)
			res += (rev.charAt(i) == '[' ? ']' : '[');
		return res;
	}
	
	// test the method mirror
	static void testMirror(Tree t) {
		assert(t.children != null) : "\nYou have not initialized properly the field children.\n";
		// first test that t.mirror is not destructing t 
		String printTree = print(t);
		t.mirror();
        assert(printTree.equals(print(t))) : "\nThe mirror method should not change the current tree, it should return a new constructed tree.";
		// then test that t.mirror returns the expected tree
		assert(print(t.mirror()).equals(mirror(print(t)))) : "\nThe mirror of the tree\n   " + print(t) + "\nis the tree\n   " + mirror(print(t)) + "\nand not the tree\n   " + print(t.mirror()) + "	\nNote that we represent inductively:\n    * a leaf by the string [] and\n    * a tree t with children {c1,...,ck} by the string s(t) = [s(c1)...s(ck)].\n";
	}

	public static void main(String[] args) {
		// check -ea option on JVM
		if (!Test312.class.desiredAssertionStatus()) {
			System.err.println("Vous devez activer l'option -ea de la JVM");
			System.err.println("(Run As -> Run configurations -> Arguments -> VM Arguments)");
			System.exit(1);
		}
				
		// test the method mirror on some examples
		System.out.print("Test de mirror ... ");
		Tree t1 = new Tree(new Tree[] {});
		Tree t2 = new Tree(new Tree[] {new Tree(), new Tree(), new Tree(new Tree[] {new Tree()})});
		Tree t3 = new Tree(new Tree[] {t1, t2});
		Tree t4 = new Tree(new Tree[] {new Tree(), new Tree(new Tree[] {new Tree(), new Tree(), new Tree()}), t3});
		
		testMirror(t1);
		testMirror(t2);
		testMirror(t3);
		testMirror(t4);

		System.out.println("[OK]");
	}
}
