
public class Test313 {
	
	// print a tree
	static String print(Tree t) {
		String res = "[";
		for (Tree child : t.children)
			res += print(child);
		return res + "]";
	}

	// test the method regularTree
	static void testRegularTree(Tree t, int degree, int height) {
		assert(t.children != null) : "\nYou have not initialized properly the field children.\n";
		if (height == 1)
			assert(t.children.length == 0) : "\nYour tree\n   " + print(t) + "\nis two high.\n";
		else
			assert(t.children.length == degree) : "\nThe root of your tree\n   " + print(t) + "\nhas " + t.children.length + " children instead of " + degree + ".\n";
		for (Tree child : t.children)
			testRegularTree(child, degree, height - 1);
	}
	
	public static void main(String[] args) {
		// check -ea option on JVM
		if (!Test313.class.desiredAssertionStatus()) {
			System.err.println("Vous devez activer l'option -ea de la JVM");
			System.err.println("(Run As -> Run configurations -> Arguments -> VM Arguments)");
			System.exit(1);
		}
				
		// test the method regularTree on some examples
		System.out.print("Test de regularTree ... ");
		for (int degree = 1; degree < 5; degree++)
			for (int height = 1; height < 6; height++) {
				Tree t = Tree.regularTree(degree, height);
				testRegularTree(t, degree, height);
			}
		System.out.println("[OK]");
	}
}
