import java.util.LinkedList;

public class Test3241 {

	// print a tree
	static String print(Tree t, boolean verbose) {
		String res = "[";
		for (Tree child : t.children)
			res += print(child, false);
		return res + "]";
	}
	
	// preorder traversal of the tree
	static void preorder(Tree t, LinkedList<Float> reading) {
		reading.add(t.relativePosition);
		for (Tree child : t.children)
			preorder(child, reading);
	}

	// test the method computeDrawing
	static void testComputeDrawing(Tree t, float[] descendantPositions) {
		LinkedList<Float> relativePositions = new LinkedList<Float>();
		preorder(t, relativePositions);
		int i = 0;
		while(!relativePositions.isEmpty()) {
			assert(relativePositions.removeFirst() == descendantPositions[i]) : "Bad relative position.";
			i++;
		}
	}
	
	// print list
	static String print(LinkedList<Float> l) {
		if (l.isEmpty()) return "}";
		return l.removeFirst() + ", " + print(l);
	}
	

	public static void main(String[] args) {
		// check -ea option on JVM
		if (!Test3241.class.desiredAssertionStatus()) {
			System.err.println("Vous devez activer l'option -ea de la JVM");
			System.err.println("(Run As -> Run configurations -> Arguments -> VM Arguments)");
			System.exit(1);
		}

		// test the method computeDrawing on some examples
		System.out.print("Test de computeDrawing ... ");
		
		Tree t1 = new Tree();
		Tree t2 = new Tree(new Tree[] {new Tree(), new Tree(), new Tree(new Tree[] {new Tree()})});
		Tree t3 = new Tree(new Tree[] {new Tree(), new Tree(new Tree[] {new Tree(), new Tree(), new Tree(new Tree[] {new Tree()})})});
		Tree t4 = new Tree(new Tree[] {new Tree(), new Tree(new Tree[] {new Tree(), new Tree(), new Tree()}), new Tree(new Tree[] {new Tree(), new Tree(new Tree[] {new Tree(), new Tree(), new Tree(new Tree[] {new Tree()})})})});

		t1.computeDrawing();
		t2.computeDrawing();
		t3.computeDrawing();
		t4.computeDrawing();

		testComputeDrawing(t1, new float[] {0});
		testComputeDrawing(t2, new float[] {0, -1, 0, 1, 0});
		testComputeDrawing(t3, new float[] {0, (float) -0.5, (float) 0.5, -1, 0, 1, 0});
		testComputeDrawing(t4, new float[] {0, (float) -1.75, (float) -0.75, -1, 0, 1, (float) 1.75, (float) -0.5, (float) 0.5, -1, 0, 1, 0});
		
		System.out.println("[OK]");
	}
}
